
package com.persagy.server

import com.sybotan.service.json.SJsonHttpMessageConverter
import org.mybatis.spring.annotation.MapperScan
import org.slf4j.LoggerFactory
import org.springframework.boot.SpringApplication
import org.springframework.boot.autoconfigure.SpringBootApplication
import org.springframework.boot.builder.SpringApplicationBuilder
import org.springframework.boot.web.servlet.support.SpringBootServletInitializer
import org.springframework.context.annotation.Bean
import org.springframework.context.annotation.ComponentScan
import org.springframework.scheduling.annotation.EnableScheduling

/**
 * 应用配置
 *
 * @author  Andy
 */
@ComponentScan(basePackages = ["com.persagy.server", "com.persagy"])    // 配置组件扫描路径 需要扫描的路径列表
@MapperScan("com.persagy", "com.persagy.server")                       // Mapper组件扫描路径 需要扫描的路径列表
@SpringBootApplication // 生命启动类
@EnableScheduling      // 项目中可以使用定时任务
open class DataCenterApp : SpringBootServletInitializer() {
    companion object {
        // 日志
        private val logger = LoggerFactory.getLogger(DataCenterApp::class.java)
    } // Companion object

    /**
     * 配置应用
     *
     * @param   application     应用构建对象
     */
    override fun configure(application: SpringApplicationBuilder): SpringApplicationBuilder {
        return application.sources(DataCenterApp::class.java)
    } // Function configure

} // Class Application

/**
 * Web应用入口
 *
 * @param   args        命令行参数
 */
fun main(args: Array<String>) {
    SpringApplication.run(DataCenterApp::class.java, *args)
    return
} // Function main()
