
package com.persagy.server

import com.sybotan.service.interceptors.SPageInterceptor
import org.springframework.context.annotation.Configuration
import org.springframework.web.servlet.config.annotation.InterceptorRegistry
import org.springframework.web.servlet.config.annotation.WebMvcConfigurerAdapter

@Suppress("DEPRECATION")
@Configuration
open class WebMvcConfg: WebMvcConfigurerAdapter() {

    /**
     * 配置拦截器
     *
     * @param   registry        拦截器注册器
     */
    override fun addInterceptors(registry : InterceptorRegistry) {
        registry.addInterceptor(SPageInterceptor()).addPathPatterns("/**")
        super.addInterceptors(registry)
    } // Function addInterceptors()
} // Class WebMvcConf()