# 配置
## 配置 hosts文件

## 挂载扩展盘
### 确认是否有扩展盘
查是否有扩展盘，linux 设备文件说明( dev 后面可能是 vd 、hd 、sd , sd（sata 接口本地硬盘），hd (早期 ide 接口硬盘)，vd 虚拟磁盘)
vda 和 vda1 代表做过磁盘分区，只有 vdb 没有 vdb1 代表还没做磁盘分区，还不能使用（vda  第一位盘的类型，第二位固定的 d
第三位是第几块盘，从 a 到 z ,第四位代表第几个分区）
```
[root@iZ2zeg1jwq8q9et5pxzaeaZ ~]# ls /dev/vd*
/dev/vda  /dev/vda1  /dev/vdb
```
### 扩展盘分区
::: danger 警告

1.非专业人士不要进行操作，会导致系统崩溃，数据丢失，责任自负。

2.已经做完分区的不需要执行此步骤。
::: 

创建分区命令，指定没有分区的磁盘
```metadata json
fdisk /dev/vdb
```
输入 m  显示菜单 ，然后输入 n 添加一个新的分区的配置，w 分区配置写入磁盘，完成扩展分区。

![扩展盘分区 centos7-fdisk_001](./img/centos7-fdisk_001.jpg)

### 格式化
::: danger 警告

1.非专业人士不要进行操作，会导致系统崩溃，数据丢失，责任自负。

2.已经做完分区的不需要执行此步骤。

3.格式化时一定注意盘符，不要是vba1,注意，注意，注意 ，vba1 为系统盘符
::: 
```
mkfs.ext4 /dev/vdb1
```

![格式化 centos7-fdisk_001](./img/centos7-fdisk_001.jpg)

### 查看磁盘的 UUID
```
[root@sybotan ~]# blkid
/dev/vda1: UUID="87ba1103-a0d7-49ef-a8ae-6ce1d3fd2453" TYPE="ext4" 
/dev/vdb1: UUID="ee865766-b0d0-4518-8969-49e432f23838" TYPE="ext4" 
```

### 编辑文件“/etc/fstab”，
```metadata json
vi /etc/fstab
```

将扩展盘挂载到“/opt”
```
UUID=ee865766-b0d0-4518-8969-49e432f23838 /opt                    ext4    defaults        0 0
```

### 执行挂载生效
```metadata json
mount -a
```

查询是否挂载成功
```metadata json
df -h
```
![查看 centos7-fdisk_001](./img/centos7-fdisk_002.png)

或者重启系统

```
reboot
```
注：在实际的配置中， UUID 的值要改为实际挂载盘的 UUID 。
