# docker
## Docker 安装 

此处在 Centos7 进行安装，linux 3.10 内核，docker 官方说至少 3.8 以上，建议 3.10 以上（ubuntu 下要 linux 内核 3.8 以上， RHEL / Centos 的内核修补过， centos6.5 的版本就可以——这个可以试试）

### 查看 linux 发行版，内核
查看版本号
```metadata json
[root@localhost persagy]# cat /etc/redhat-release
```
![docker 安装](./img/docker_0001.jpg)

查看 Linux 内核
```metadata json
[root@localhost persagy]# uname -r
```
![docker 安装](./img/docker_0002.jpg)

### 替换阿里云 yum 源
下载阿里 yum 源
```metadata json
[root@localhost persagy]# wget -O /etc/yum.repos.d/CentOS-Base.repo http://mirrors.aliyun.com/repo/Centos-7.repo
```
![docker 安装](./img/docker_0003.jpg)

生成仓库缓存 
```
[root@localhost persagy]# yum makecache
```
#### 安装 docker
```metadata json
[root@localhost persagy]# yum install docker -y
```

### docker 启动 
启动 docker
```metadata json
[root@localhost persagy]# systemctl start docker
```

开机启动 docker
```metadata json
[root@localhost persagy]# systemctl enable docker
```

查看 docker 状态
```metadata json
[root@localhost persagy]# systemctl status docker
```
### 查看 docker 版本
```metadata json
[root@localhost persagy]# docker version
```
### 加速器
DaoCloud 加速器 是广受欢迎的 Docker 工具，解决了国内用户访问 Docker Hub 缓慢的问题。DaoCloud 加速器结合国内的 CDN 服务与协议层优化，成倍的提升了下载速度。
使用前请先确保您的 Docker 版本在 1.8 或更高版本，否则无法使用加速。
http://guide.daocloud.io/dcs/daocloud-9153151.html 教程官网

查看 daemon.json 中的内容 
```
[root@localhost persagy]# cat /etc/docker/daemon.json
```
![docker 安装](./img/docker_0004.jpg)

如果是空的，直接修改 daemon.json
```metadata json
[root@localhost persagy]# vi /etc/docker/daemon.json
```
```metadata json
{
    "registry-mirrors": [
        "http://95822026.m.daocloud.io"
    ],
    "insecure-registries": []
}
```
保存退出，或者使用另外一条命令直接修改
```metadata json
[root@localhost persagy]# curl -sSL https://get.daocloud.io/daotools/set_mirror.sh | sh -s http://95822026.m.daocloud.io
```
#### 注意 
修改的内容里面可能多了一个逗号，使用命令查新
```metadata json
[root@localhost persagy]# cat /etc/docker/daemon.json
```
![docker 安装](./img/docker_0005.jpg)

使用 vi 打开 daemon.json 文件去掉多余的逗号

![docker 安装](./img/docker_0006.jpg)

重启 docker
```metadata json
[root@localhost persagy]# systemctl restart docker
```
### 查看版本
```metadata json
[root@localhost persagy]# docker version
```
![docker 安装](./img/docker_0007.jpg)


## 修改 docker 存储位置













